"""
Character field class: a 8-bit character
"""

from hachoir.field import Bits
from hachoir.endian import BIG_ENDIAN

class Character(Bits):
    static_size = 8

    def __init__(self, parent, name, description=None):
        Bits.__init__(self, parent, name, 8, description=description)

    def _createValue(self):
        return chr(self._parent.stream.readBits(
            self.absolute_address, 8, BIG_ENDIAN))
