from hachoir.field import (Bit, Bits,
    GenericString, RawBytes,
    PaddingBits, PaddingBytes)

def createRawField(parent, size, name="raw[]", description=None):
    assert 0 < size
    if size == 1:
        return Bit(parent, name)
    if (size % 8) == 0:
        return RawBytes(parent, name, size/8, description)
    else:
        return Bits(parent, name, size, description)

def createPaddingField(parent, nbits, name="padding[]", description=None):
    assert 0 < nbits
    if (nbits % 8) == 0:
        return PaddingBytes(parent, name, nbits/8, description)
    else:
        return PaddingBits(parent, name, nbits, description)

def isString(field):
    return issubclass(field.__class__, GenericString)

