from hachoir.field import isString

class Grep:
    def __init__(self):
        self.pattern = None
        self.case_sensitive = True

    def grep(self, fieldset):
        for field in fieldset:
            if field.is_field_set:
                self.grep(field)
                field.reset()
            elif isString(field) and self.match(field):
                self.onMatch(field)

    def match(self, field):
        value = field.value
        if len(value) == 0:
            return False
        if not self.pattern:
            return True
        if not self.case_sensitive:
            value = value.lower()
        return self.pattern in value

    def onMatch(self, field):
        raise NotImplementedError()

